# MovedObject Product
# Redirects requests to objects that have replaced some object.
# J. Cameron Cooper
#
# Copyright 2003 J Cameron Cooper
# licensed under the GPL: see LICENSE file for details

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo

from Acquisition import Implicit
from Globals import Persistent
from AccessControl.Role import RoleManager
from OFS import SimpleItem
# PropertyManager?

from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Globals import DTMLFile

__version__="0.1"

### ADD

manage_addMovedObjectForm = DTMLFile('www/addMovedObject',globals())
def manage_addMovedObject(self,id,title,redirect,REQUEST=None, RESPONSE=None):
    """Add Moved Object to a folder"""
    self._setObject(id, MovedObject(id,title,redirect))
    if REQUEST is not None:
        return self.manage_main(self,REQUEST)

class MovedObject(Implicit, Persistent, RoleManager, SimpleItem.SimpleItem):
    """Represents and invoice"""
    meta_type = "MovedObject"

    manage_options = (
        {'label': 'Edit', 'action': 'manage_editMovedObjectForm'},
        ) + RoleManager.manage_options + SimpleItem.SimpleItem.manage_options

    security = ClassSecurityInfo()

    def __init__(self,id,title,redirect):
        """Initializes class with standard info + redirect location."""
        self.id = str(id)
        self.title = str(title)
        self.redirect = str(redirect)

### DEFAULT VIEW
    #def __call__(self, REQUEST=None):
    def index_html(self, REQUEST=None):
        """Default view"""
        if REQUEST is not None:
            response = REQUEST.RESPONSE
            response.setStatus("MovedPermanently")
            response.redirect(self.redirect, lock=1)
        return "This resource has permanently moved to: %s" % self.redirect

### EDIT
    security.declareProtected('View management screens',
                              'manage_editMovedObjectForm',
                              'manage_editMovedObject')
    manage_editMovedObjectForm = DTMLFile('www/editMovedObject',globals())
    def manage_editMovedObject(self,title=None,redirect=None,REQUEST=None):
        if title is not None:
            self.title = str(title)
        if redirect is not None:
            self.redirect = str(redirect)
        if REQUEST is not None:
            return self.manage_editMovedObjectForm(self,REQUEST)

InitializeClass(MovedObject)
